# -*- encoding=utf8 -*-
__author__ = "liguangyu"

import json

"""
case_tag:cmdc_api,cmdc补货设置批量导入验证,31,31-25,sit,bs
主数据平台:后台运营系统补货设置批量导入接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import os

module = "cmdc_31st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers_file", cmdc_access_token)

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/补货设置模板.xlsx"

# 第二步补货设置批量导入验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url26")

request_body = commonFuc().get_business_data(module, "payload26")

# 获取文件
file = open(file_path, "rb")
files = {"file": file}

"""
 场景: 补货设置批量导入验证
 用例名称：补货设置批量导入验证
 输出：{"pacNo":"2016001"}
"""

# 发送请求
result = requests.post(url, files=files, headers=headers, data=request_body)

# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

file.close()

# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 查询数据库中新增补货设置对应的pacNo
sql = "SELECT t.pacNo FROM `cmdc-order`.tc_replenishment_setting t WHERE productCode = 10154719 and deleteSign = 0"
pac_no = mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]

# 实际结果
result = {"pacNo": pac_no}
# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict26")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
