# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc获取补货单欠货明细,31,31-33,sit,bs
主数据平台:后台运营系统获取补货单欠货明细接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import random
import requests
import json

module = "cmdc_31st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username4")
password = commonFuc().get_business_data(module, "password4")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取欠货综合管理列表_客户查询维度
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url31_1")
request_body = commonFuc().get_business_data(module, "payload31_1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
debt_random = random.randint(0, len(result["data"]["debtProductVos"]["list"]) - 1)
# 获取商品信息
customer_code = result["data"]["debtProductVos"]["list"][debt_random]["customerCode"]
distribution_type = result["data"]["debtProductVos"]["list"][debt_random]["distributionType"]
product_code = result["data"]["debtProductVos"]["list"][debt_random]["productCode"]
seller_company_code = result["data"]["debtProductVos"]["list"][debt_random]["sellerCompanyCode"]
shipment_type = result["data"]["debtProductVos"]["list"][debt_random]["shipmentType"]

# 第三步获取补货单商品详情
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url31")
request_body = commonFuc().get_business_data(module, "payload31", customer_code, distribution_type, product_code,
                                             seller_company_code, shipment_type)
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取补货信息
uuid1 = result["data"][0]["uuid"]

# 第四步获取补货单欠货明细
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url32")
request_body = commonFuc().get_business_data(module, "payload32", uuid1)

"""

 场景: 获取补货单欠货明细
 用例名称：获取补货单欠货明细
 输出：{"uuid":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取补货商品信息
result = json.loads(result.content)
result = {"uuid": result["data"][0]["uuid"]}
# print(result)
# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict32", uuid1)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

