# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc退货单日期排序功能验证_退货明细列表_降序,34,34-22,sit,be
主数据平台:后台运营系统获取退货明细列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import json

module = "cmdc_34st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步按退货单日期降序排列
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url22")
request_body = commonFuc().get_business_data(module, "payload22")

"""

 场景: 退货单日期排序功能验证_退货明细列表_降序
 用例名称：退货单日期排序功能验证_退货明细列表_降序
 输出：{"returnGoodCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取退货明细信息
result = json.loads(result.content)
result = {"returnGoodCode": result["data"]["list"][0]["returnGoodCode"]}
# 将接口响应时间添加至result
result["api_time"] = api_time

# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db_be")

# 在数据库中按退货单日期降序查询对应的退货明细信息
sql = "select * " \
      "from (select de.SDDOCO, de.SDTRDJ, td.customerCode, td.customerName, de.SHIR01, de.SDPMPN, de.qwdsc, " \
      "sku.productCode," \
      "  sku.productName, sku.productLineCode, sku.productLineName, sku.measuringUnit, td.demandCode," \
      "       td.createTime, td.auditTime, td.distributionType, td.paymentType, main.paidTime, de.sdocto," \
      "            de.sdaddj, de.SDOORN  from tc_jde_returnall_detail de" \
      "              left join tc_demand td on de.demandCode = td.demandCode" \
      "              left join tc_demand_sku sku on sku.demandCode = de.demandCode and " \
      "sku.lineNumber = de.demandLineNumber" \
      "              left join tc_demand_main main on main.demandParentId = td.demandParentId" \
      "              left join tc_manufacturer_user mu on mu.id = sku.manufacturerUserId" \
      "              left join tc_manufacturer_product mp on mp.id = sku.manufacturerProductId" \
      "     where de.sdocto != 'SN'" \
      "       and td.demandId is not null" \
      "       and td.sellerCompanyCode = '00102'" \
      "     order by de.SDTRDJ desc) tmp_count order by SDTRDJ desc"
returnGoodCode = mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict22", returnGoodCode)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

