# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc需求单-客户确认-不接受,2252,2252-29,sit,bs
主数据平台:多采商城需求单客户确认接口 
"""

from common.common_func import commonFuc
from air_case.cmdc_login.多采商城登录.多采商城登录 import CmdcMaiiLogin
import requests
import json


module = "cmdc_demand_list_pc"

# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username")
password = commonFuc().get_business_data(module, "password")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcMaiiLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 获取需求单列表查询待客户确认需求单
url1 = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url1")
request_body = commonFuc().get_business_data(module, "payload50")
# 发送请求
result = requests.post(url1, json=request_body, headers=headers)
result = json.loads(result.content)

# 判断是否获取到待确认需求单信息
if result["data"]["list"]:
    # 获取需求单信息
    demand_parent_id = result["data"]["list"][0]["demandParentId"]
    demand_id = result["data"]["list"][0]["demandId"]

    # 获取需求单进行客户确认操作
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url5")
    request_body = commonFuc().get_business_data(module, "payload5", demand_parent_id, demand_id)

    """
     场景:需求单列表进行客户确认操作
     用例名称：需求单客户确认操作
     输出：{"success":true,"code":"200","message":"ok","data":null,"freshToken":null}
    """
    # 发送请求
    result = requests.post(url, json=request_body, headers=headers)
    # 获取接口响应时间
    api_time = result.elapsed.total_seconds()
    result = json.loads(result.content)
    result["api_time"] = api_time
    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict5")
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
