# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_商品植入清单列表,2298,2298-29,sit,bs
主数据平台:后台运营系统获取商品植入清单列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_hospital"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取上报植入列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url1")
request_body = commonFuc().get_business_data(module, "payload1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
hospital_random = random.randint(0, len(result["data"]["list"]) - 1)

# 获取上报植入信息
soCode = result["data"]["list"][hospital_random]["soCode"]
demandCode = result["data"]["list"][hospital_random]["demandCode"]
# 第三步获取商品植入清单列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url31")
request_body = commonFuc().get_business_data(module, "payload31", soCode, demandCode)
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
print(result)
if result["data"]:
    # 获取商品清单信息
    productName = (result["data"][0]["productName"] if result["data"][0]["productName"] else "")
    productCode = result["data"][0]["productCode"]
    manufacturer = (result["data"][0]["manufacturer"] if result["data"][0]["manufacturer"] else "")
    optionStr = (result["data"][0]["optionStr"] if result["data"][0]["optionStr"] else "")
    ehd200 = (result["data"][0]["ehd200"] if result["data"][0]["ehd200"] else "")
    reportStatus = result["data"][0]["reportStatus"]
    hospitalName = (result["data"][0]["hospitalName"] if result["data"][0]["hospitalName"] else "")
    uniqueCode = (result["data"][0]["uniqueCode"] if result["data"][0]["uniqueCode"] else "")

    # 第四步进行列表查询条件查询
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url32")
    request_body = commonFuc().get_business_data(module, "payload32", soCode, productName, productCode, manufacturer,
                                                 optionStr, ehd200, reportStatus, hospitalName, uniqueCode, demandCode)

    # 发送请求
    result = requests.post(url, json=request_body, headers=headers)
    # 获取接口响应时间
    api_time = float(result.elapsed.total_seconds())

    # 获取商品信息
    result = json.loads(result.content)
    result = {"productCode": result["data"][0]["productCode"]}
    # 将接口响应时间添加至result
    result["api_time"] = api_time

    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict32", productCode)
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)

"""
 场景: 列表查询条件验证_商品植入清单列表
 用例名称：列表查询条件验证_商品植入清单列表
 输出：{"productCode":"%s"}
"""