# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc批量导出功能验证_省份植入指标信息列表,2300,2300-17,sit,be
主数据平台:后台运营系统获取省份植入指标信息批量导出接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import random
import json
import os


module = "cmdc_ls"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取省份植入指标信息列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url15")
request_body = commonFuc().get_business_data(module, "payload15")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

if result["data"]["list"]:
    # 生成随机数
    pro_random = random.randint(0, len(result["data"]["list"]) - 1)
    # 获取省份植入信息
    statisticProvince = result["data"]["list"][pro_random]["statisticProvince"]
    statisticMonth = result["data"]["list"][pro_random]["statisticMonth"]
    statisticYear = result["data"]["list"][pro_random]["statisticYear"]

    # 第三步进行信息批量导出
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url17")
    request_body = commonFuc().get_business_data(module, "payload17", statisticProvince, statisticMonth, statisticYear)

    """
    
     场景: 批量导出功能验证_省份植入指标信息列表
     用例名称：批量导出功能验证_省份植入指标信息列表
     输出：{"statisticProvince":"%s"}
    """

    # 发送请求
    result = requests.post(url, json=request_body, headers=headers)
    # 获取接口响应时间
    api_time = float(result.elapsed.total_seconds())

    # 获取文件
    BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
    file_path = BASE_DIR + "/data/cmdc_files/省份植入指标明细.xlsx"

    # 获取到导出文件存入cmdc_files文件中
    with open(file_path, 'wb') as f:
        f.write(result.content)

    # 获取导出文件中身份植入指标信息
    excel = HandleExcel(file_path, "Sheet1")
    result = {"statisticProvince": excel.read_data()[0].get("省份")}

    # 将接口响应时间添加至result
    result["api_time"] = api_time

    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict17", statisticProvince)
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
