# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc商品行明细导出验证_订单维度_欠货综合管理,2295,2295-119,sit,bs
主数据平台:后台运营系统商品行明细导出接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import random
import json
import os

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取欠货综合管理列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url118")
request_body = commonFuc().get_business_data(module, "payload118")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
debt_random = random.randint(0, len(result["data"]["queryDemandPageInfo"]["list"]) - 1)
# 获取欠货信息
demandParentCode = result["data"]["queryDemandPageInfo"]["list"][debt_random]["demandParentCode"]

# 第三步进行商品明细导出
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url119")
request_body = commonFuc().get_business_data(module, "payload119", demandParentCode)

"""

 场景: 商品行明细导出验证_订单维度_欠货综合管理
 用例名称：商品行明细导出验证_订单维度_欠货综合管理
 输出：{"demandParentCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/欠货商品行明细.xlsx"

# 获取到导出文件存入cmdc_files文件中
with open(file_path, 'wb') as f:
    f.write(result.content)

# 获取导出文件中需求单号
excel = HandleExcel(file_path, "Sheet1")
# print(excel.read_data())
result = {"demandParentCode": excel.read_data()[0].get("母需求单编号")}

# 将接口响应时间添加至结果中
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict119", demandParentCode)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
