# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc推送已推送成功的jde配货单拦截验证,2295,2295-32,sit,bs
主数据平台:后台运营系统jde配货推送接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取已完成推送的配货单信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url19_1")
request_body = commonFuc().get_business_data(module, "payload19_1")
# 发送请求
result = requests.get(url, params=request_body, headers=headers)
result = json.loads(result.content)

# 判断是否成功获取到已完成推送的配货单信息
if result["data"]["list"]:
    # 生成随机数
    dis_random = random.randint(0, len(result["data"]["list"]) - 1)
    # 获取配货单信息
    distribution_jde_ds_id = result["data"]["list"][dis_random]["distributionJdeDsId"]
    distribution_jde_ds_code = result["data"]["list"][dis_random]["distributionJdeDsCode"]

    # 第三步进行jde配货单推送
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url32")
    request_body = commonFuc().get_business_data(module, "payload32", distribution_jde_ds_id)

    """
    
     场景: 合并已推送配货单校验验证
     用例名称：合并已推送配货单校验验证
     输出：{"success":true,"code":"200","message":"OK","data":"fail"}
    """

    # 发送请求
    result = requests.get(url, params=request_body, headers=headers)
    # 获取接口响应时间
    api_time = float(result.elapsed.total_seconds())

    result = json.loads(result.content)
    # 将接口响应时间添加至result
    result["api_time"] = api_time
    # 手动推送和自动推送接口返回提示不同
    if result["success"]:
        # 获取预期结果
        check_dict = commonFuc().get_business_data(module, "checkDict32_1")
        # print(check_dict)
        # 断言实际结果中是否包含预期结果的内容
        commonFuc().check_result(check_dict, result)
    else:
        # 获取预期结果
        check_dict = commonFuc().get_business_data(module, "checkDict32_2")
        # print(check_dict)
        # 断言实际结果中是否包含预期结果的内容
        commonFuc().check_result(check_dict, result)
