# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc商品限购金额配置新增,2293,2293-82,sit,bs
主数据平台:运营后台管理系统商品限购金额配置新增接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_product"

# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 获取商品列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url82_1")
request_body = commonFuc().get_business_data(module, "payload82_1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取商品信息
product_random = random.randint(0, len(result["data"]["list"]) -1)
productCode = result["data"]["list"][product_random]["productCode"]

# 获取客户列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url82_2")
request_body = commonFuc().get_business_data(module, "payload82_2")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result1 = json.loads(result.content)

# 获取客户信息
customer_random = random.randint(0, len(result1["data"]["list"]) -1)
customerCode = result1["data"]["list"][customer_random]["customerCode"]

# 商品限购金额配置新增
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url82")
request_body = commonFuc().get_business_data(module, "payload82", productCode, customerCode)

"""
 场景: 商品限购金额配置新增功能验证
 用例名称：商品限购金额配置新增
 输出：{"success":true,"code":"200","message":null,"data":null,"freshToken":null}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
# 将接口响应时间添加至result
result = json.loads(result.content)
result["api_time"] = api_time
# print(result)
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict82")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)


