# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc获取商品限购金额列表,2293,2293-81,sit,bs
主数据平台:运营后台管理系统获取商品限购金额列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import json

module = "cmdc_product"

# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 获取商品限购金额列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url81")
request_body = commonFuc().get_business_data(module, "payload81")

"""
 场景: 获取商品限购金额列表
 用例名称：获取商品限购金额列表
 输出：{"total":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)

# 获取限购金额商品数量
result = {"total": result["data"]["total"]}
result["api_time"] = api_time
# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 数据库配置限购金额商品数量
sql = "SELECT count(1) FROM `cmdc-product`.ic_product_limit_buy t " \
      "WHERE filialeCode = '00111' and deleteSign = 0 and limitType = 1"
total = (
    mysql_handle.selectSql(host, port, user, pwd, "cmdc-product", sql)[0][0]
    if mysql_handle.selectSql(host, port, user, pwd, "cmdc-product", sql) else 0)

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict81", total)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
