# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc查看物流详情_三方需求单,00,00-29,sit,be
主数据平台:后台运营系统查看物流信息接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import datetime
import requests
import random
import json

module = "cmdc_special_version"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取待发货列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url27")
request_body = commonFuc().get_business_data(module, "payload27")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
so_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取三方需求单信息
soCode = result["data"]["list"][so_random]["soCode"]
demandParentCode = result["data"]["list"][so_random]["demandParentCode"]

# 第二步查看物流
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url29")
request_body = commonFuc().get_business_data(module, "payload29", soCode, demandParentCode)

"""
 场景: 查看物流详情_三方需求单
 用例名称：查看物流详情_三方需求单
 输出：{"sddoco":"%s"}
"""

# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取物流信息
result = json.loads(result.content)
# print(result)
result = {"sddoco": result["data"]["detail"][0]["SDDOCO"]}
# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict29", soCode)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

