# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc客户联系人信息修改功能验证,2256,2256-29,sit,bs
主数据平台:后台运营系统客户联系人信息修改接口 
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import json

module = "cmdc_website"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username")
password = commonFuc().get_business_data(module, "password")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

# 第二步获取站点客户联系人列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url28")
request_body = commonFuc().get_business_data(module, "payload28")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取客户联系人信息
name = result["data"]["list"][0]["name"]
telephone = result["data"]["list"][0]["telephone"]
contactId = result["data"]["list"][0]["contactId"]

# 第三步进行客户联系人信息修改操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url29")
request_body = commonFuc().get_business_data(module, "payload29", name, telephone, contactId)

"""

 场景: 客户联系人信息修改功能验证
 用例名称：客户联系人信息修改功能验证
 输出：{"success":true,"code":"200","message":"操作成功","data":null,"freshToken":null}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 将接口响应时间添加至result
result = json.loads(result.content)
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict29")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

