# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc获取合作站点详情信息,2256,2256-51,sit,bs
主数据平台:多采商城站点获取合作站点详情信息接口 
"""

from common.common_func import commonFuc
from air_case.cmdc_login.多采商城登录.多采商城登录 import CmdcMaiiLogin
import requests
import random
import json

module = "cmdc_website"

# 第一步获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcMaiiLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取已合作站点列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url49")
request_body = commonFuc().get_business_data(module, "payload49")
# 发送请求
result = requests.get(url, params=request_body, headers=headers)
result = json.loads(result.content)

# 判断是否获取到已合作站点信息
if result["data"]:
    # 生成随机数
    company_random = random.randint(0, len(result["data"]) - 1)
    # 获取站点信息
    userId = result["data"][company_random]["userId"]
    companyId = result["data"][company_random]["companyId"]

    # 第三步获取合作站点详情信息
    url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url51")
    request_body = commonFuc().get_business_data(module, "payload51", userId, companyId)
    # print(request_body)
    """
     场景:获取合作站点详情信息
     用例名称：获取合作站点详情信息
     输出：{"userId":"%s"}
    """

    # 发送请求
    result = requests.get(url, params=request_body, headers=headers)
    # 获取接口响应时间
    api_time = float(result.elapsed.total_seconds())

    # 获取站点信息
    result = json.loads(result.content)
    # print(result)
    result = {"userId": result["data"]["userId"]}

    # 将接口响应时间添加至result
    result["api_time"] = api_time

    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict51", userId)
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
